// -*-mode:c++; c-style:k&r; c-basic-offset:4;-*-
//
// Copyright 2015, Julian Catchen <jcatchen@illinois.edu>
//
// This file is part of Chromonomer.
//
// Chromonomer is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Chromonomer is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Chromonomer.  If not, see <http://www.gnu.org/licenses/>.
//

#ifndef __CONSTANTS_H__
#define __CONSTANTS_H__

//
// Pull in the configuration variables from the configure script
//
#if HAVE_CONFIG_H
#include "config.h"
#endif

//
//
//
const unsigned int fieldw = 4;

//
// Maximum line length for parsing input files.
//
const int max_len = 1024;

//
// Maximum length of idetifiers, such as sequence IDs and chromosome names.
//
const int id_len = 255;

//
// FASTA line length.
//
const int fasta_line_len = 80;

enum strand_type {plus, minus};
enum comp_type   {gap, contig};
enum ann_type    {seg_beg, seg_end};
enum ori_type    {ori_forward, ori_reverse, ori_unknown};
enum dynprg_type {path_left, path_diagup};

#endif
