// -*-mode:c++; c-style:k&r; c-basic-offset:4;-*-
//
// Copyright 2016, Julian Catchen <jcatchen@illinois.edu>
//
// This file is part of Chromonomer.
//
// Chromonomer is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Chromonomer is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Chromonomer.  If not, see <http://www.gnu.org/licenses/>.
//

#ifndef __SPLITS_H__
#define __SPLITS_H__

#include <iostream>
#include <fstream>
using std::ofstream;
using std::cerr;
#include <utility>
using std::pair;
using std::make_pair;
#include <string>
using std::string;
#include <vector>
using std::vector;
#include <map>
using std::map;
#include <sstream>
using std::stringstream;
#include <stack>
using std::stack;

#include "constants.h"
#include "scaffold.h"
#include "linkage_map.h"

extern string scaffold_prefix;
extern bool   split_scaffolds;
extern bool   verbose;

int print_scaffold_map(vector<ScafComp> &, ofstream &, bool);
int split_scaffold(string, map<int, vector<Marker> > &, ori_type, map<string, vector<ScafComp> > &, map<uint, Marker> &, map<uint, Marker> &, int &, ofstream &);
int hang_annotations(map<int, vector<Marker> > &, ori_type, vector<ScafComp> &);
int serialize_annotations(vector<ScafComp> &, vector<ScafAnn> &);
int prune_segment(map<int, vector<Marker> > &, ScafAnn, ScafAnn, vector<ScafComp> &, map<uint, Marker> &, ofstream &);
int reduce_to_majority_segment(string, map<int, vector<Marker> > &, vector<ScafComp> &, map<uint, Marker> &, ofstream &);
int remove_annotations(vector<ScafAnn> &, uint);

#endif // __SPLITS_H__
